/* gkf windows */ 
/*gkf  9jul02 rotsphere  */
/* gkf 2jul02 projection */
/****************************************************************/
/****    skel.c = OpenSkelGlut.c = Noosh97 with CAVE removed ****/
/****    (C) 1994 Board of Trustees University of Illinois   ****/ 
/****    A Model Real-Time Interactive OpenGL Application    ****/
/****    George Francis, Glenn Chappell, Chris Hartman       ****/
/****    e-mail  gfrancis@math.uiuc.edu                      ****/
/******* revised 16jan2K by gkf**********************************/
/******* Exercise one solved and Stuarts gadgets too ************/
/****************************************************************/

#define random rand  /* for windows */

/* put this into the source code */
#pragma warning (disable:4305)  /* double-to-float  */
#pragma warning (disable:4101)	/* unreferenced local variable */
#pragma warning (disable:4056)	/* overflow in fp constant arithmetic */
#pragma warning (disable:4047)
#pragma warning (disable:4024)
#pragma warning (disable:4133)



#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys\timeb.h>    /* for the speedometer */
#include <gl\glut.h>
#define  MAX(x,y)         (((x)<(y))?(y):(x))
#define  MIN(x,y)         (((x)<(y))?(x):(y))
#define  ABS(u)           ((u)<0 ? -(u): (u))
#define  FOR(a,b,c)       for((a)=(b);(a)<(c);(a)++)
#define  DOT(p,q)         ((p)[0]*(q)[0]+(p)[1]*(q)[1]+(p)[2]*(q)[2])
#define  NRM(p)           sqrt(DOT((p),(p)))
#define  M_PI          (355./113.)
#define  DG            (M_PI/180)
#define  S(u)          sin((u)*DG)
#define  C(u)          cos((u)*DG)
#define  CLAMP(x,u,v) (x<u? u : (x>v ? v: x))
#define  VERT         6
/* global variables */
float r1, r2;   /* torus radiie */
float gap, gap0=1.; /* kludge so that arguments() can set a default gap0 */
float lux[3]={1.,2.,3.};             /*world light direction vector     */
float luxx[3];                       /*  object space  direction vector*/
float amb, pwr ;             /* ambient fraction, pseudo-specular power */
float mysiz,speed, torq, focal, wfar; /*console navigation variables         */
int win = 1;                   /* 2 full screen, use 0 for demand sized */
unsigned int BUT, XX, YY,SHIF;     /* used in chaptrack gluttery           */ 
int xt,yt;                       /* once was xt,yt,xm,ym for viewportery */
int mode,morph,msg,binoc;            /* pretty global */
int th0, th1, dth, ta0, ta1, dta;    /* torus parameters */
#define FLYMODE  (0)
#define TURNMODE (1) 
int place; /* matrix is being rotated by the mouse */
#define AFF      (0)
#define SPH      (1)

int ii, jj, kk;  float tmp, temp;   /* saves gray hairs later */
float aff[16], starmat[16], mat[16]; 
float prj[16]= { 3,0,0,0,    /* conformal projection */
                 0,3,0,0,
                 0,0,2,-2,
                 0,0,-1,1};
float sph[16];   /* jms-rotate-sphere-matrix */

int binoc;    /* flag                       */
float nose;   /* to eye distance in console */
int hasnumber, number, decimal, sign ; /* for Stuart's number parser */

float vv[VERT][3]={{ 0.300775, 1.301248,-0.702434},
                   {-0.976281,-0.910795, 0.701983},
                   { 0.976171,-0.910795,-0.702076},
                   {-0.300495, 1.300967, 0.702620},
                   {-1.276451,-0.390204,-0.702474},
                   { 1.276282,-0.390420, 0.702384}};
float pcan[16]; /* place the can */
float ptor[16]; /* place the tor arc */
float ww[VERT][3];
float alpha;
float color[3];
float lift;
float aitch=1.0, kay= -2, ell = -10;
int tan1,tan2,cur2;
float thick;
int friz;
int tubed; /* whether the curves are tubed*/
/**********************************************************************/
kommrusch(int fr, int to){ /* Self-initializing function draws a cube.*/
     static int virgin=1;  /* Steve Kommrusch, Math 198, 1984 */
     static float cc,ss;
     static float hcube[16][4];
     static int ep[]={ 0, 1, 3, 2, 0,      /* Eulerian path */
                       4, 5, 7, 6, 4,
                      12,13,15,14,12,
                       8,
                          9,13, 5, 1, 9,
                          11, 15, 7, 3, 11,
                          10, 14, 6, 2, 10,
                       8, 0};

     if(virgin){ virgin=0;    /* corners of a body-centered cube */
        FOR(ii,0,16)FOR(jj,0,4)hcube[ii][jj]=(ii&(1<<jj))?-1.5:1.5;
        cc = cos(M_PI/180); ss = sin(M_PI/180); /* 1 degree rotations */
     }
      FOR(ii,0,16){ /* rotate from axis "fr" to axis "to" by 1 deg */
      float aa, bb; 
      aa = hcube[ii][fr] * cc - ss * hcube[ii][to];
      bb = hcube[ii][to] * cc + ss * hcube[ii][fr];
      hcube[ii][fr]=aa;  hcube[ii][to]=bb;
      }
    glColor3f(1.,1.,1.); glLineWidth(2);
    glBegin(GL_LINE_STRIP); 
       FOR(ii,0,33) glVertex3fv( hcube[ep[ii]]); 
    glEnd();
} 


/**********************************************************************/
void autotymer(int reset){ /* cheap animations */
#define  TYME(cnt,max,act) {static cnt; if(first)cnt=max; else\
                            if(cnt?cnt--:0){ act ; goto Break;}}
  static first = 1;  /* the first time autymer is called */
  if(reset)first=1;  /* or if it is reset to start over  */
  TYME( shrink , 150,th0++;th1--;ta0++;ta1--)
  TYME( pause  , 20,          )
  TYME( grow   , 150,th0--;th1++;ta0--;ta1++)
  TYME( dwell  , 30,            )
  TYME(finish  , 1 , first = 1  )
  first = 0;
  Break:   ;   /* yes Virginia, C has gotos */
}
/**********************************************************************/
void deFault(void){
float nn;
aitch=1; kay=-2; ell=-10;
r1 = 1; r2 = .05;
th0=0; th1=356;  ta0=0; ta1=356; gap = gap0; 
msg=1; binoc=0; nose=.06; mode=TURNMODE;  
speed=.1; torq=.02; focal = 2.; wfar =1000.; mysiz=.01; morph=0; 
alpha=1;
color[0]=color[1]=color[2]=1;
lift=.01;
tan1=1;tan2=0;cur2=1;
thick=.1 ;
friz=0;
tubed=0; 
FOR(ii,0,16) starmat[ii]=sph[ii]=aff[ii] = (ii/4==ii%4);   /* identities */ 
nn=NRM(lux);
FOR(ii,0,3)lux[ii]/=nn; amb = .3; pwr = 10. ;
aff[12]=0; aff[13]= 0; aff[14]= -4.2;   /* place where we can see it */
sph[12]=0; sph[13]= 0; sph[14]= -4.2;   /* place where we can see it */
autotymer(1); /* reset autotymer to start at the beginning */
}
/**********************************************************************/
void drawvert(int th, int ta){  
float lmb,spec,nn[3], dog, cat;
nn[0] = C(th)*C(ta); /* unit sphere radius vector */  
nn[1] = S(th)*C(ta);
nn[2] =       S(ta);
lmb = DOT(nn,luxx);lmb =(lmb<0 ? .2 : lmb);  lmb = MAX(amb, lmb); 
spec = CLAMP((1.1 - pwr+pwr*lmb), 0., 1.);  
/*dog = (ta-ta0)/(float)(ta1-ta0); cat = (th-th0)/(float)(th1-th0);*/
glColor3f(
  MAX(spec, lmb*color[0]/*dog*/),                    /* map R^2(dog,cat)->R^3(RGBspace */
  MAX(spec, lmb*color[1]/*(.25 + ABS(cat -.5))*/),  /* dog cat model of Hartman       */
  MAX(spec, lmb*color[2]/*(1 - cat)*/));            /* illiLight by Ray Idaszak 1989  */
glVertex3f(
  r1*C(th) + r2*nn[0],
  r1*S(th) + r2*nn[1],
          r2*nn[2]);
} /* end drawvert */
/**********************************************************************/
void drawtor(void){
int th, ta;
dth = (int)((th1-th0)/24);  /* 24  meridian strips */ 
dta = (int)((ta1-ta0)/24);  /* 24  triangle pairs per strip */
for(th=th0; th < th1; th += dth){
  glBegin(GL_TRIANGLE_STRIP);
  for(ta=ta0; ta <= ta1; ta += dta){ 
    drawvert(th,ta); drawvert(th+gap*dth,ta);
  }
  glEnd();
  } /* end for.theta loop */
}   /* end drawtor */
/**********************************************************************/
void drawcube(void){ kommrusch(1,3);}
/**********************************************************************/
void drawall(void){ drawtor(); /* drawcube(); */ }
/**********************************************************************/
void drawstars(void){ 
     static float star[1000][3]; static int virgin=1;
 if(virgin){  /* first time  set up the stars */
     FOR(ii,0,1000)FOR(jj,0,3)star[ii][jj]=random()/(float)0x40000000-1.;
     virgin=0; /* never again */
  }
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();   /* insurance of superstition */
  glMultMatrixf(starmat);
  glColor3f(1.0,1.0,0.0);    
  glBegin(GL_POINTS);
    FOR(ii,0,1000)glVertex3fv(star[ii]);
  glEnd();
  glPopMatrix();
  glClear(GL_DEPTH_BUFFER_BIT); /* so the stars are behind everything */
}
/**********************************************************************/
#if 0
void arguments(int argc,char **argv){
  extern char *optarg;
  extern int optind; 
  int chi;   
  /* w: needs ONE number after -w, c<nothing> means NO number follows*/ 
  while ((chi = getopt(argc,argv,"w:d:g:")) != -1) 
  switch(chi)  {
                case 'w': win=atoi(optarg); break; 
                case 'g': gap0=atof(optarg); break;
                }
  if (optind!=argc) fprintf(stderr,"%s: Incorrect usage\n",argv[0]);
}
#endif

/************************ steering ***********************************/
void arguments(int argc,char **argv){           /* Pat Hanrahan 1989 */
      while(--argc){++argv; if(argv[0][0]=='-')switch(argv[0][1]){
      case 'w': win =atoi(argv[1]); argv++; argc--; break; 
      case 'g': gap0 =atof(argv[1]); argv++; argc--; break;
      case 'L': lux[0]=atof(argv[1]);
                lux[1]=atof(argv[2]);
                lux[2]=atof(argv[3]); argv +=3; argc -=3; break;
   }}}
/**********************************************************************/

/**********************************************************************/
/* Stuart Levy  1998  improved gadgets  getnumber, bump                */
/**********************************************************************/
float getnumber(float dflt){    /* dflt is an action or a constant */ 
      if(!hasnumber)return dflt;  /* in case no number to put in */
      tmp = sign ? -number : number;  
      return decimal>0 ? tmp/(float)decimal : tmp ;
}
/**********************************************************************/
void bump(float *val, float incr){ /* use bump(&nose, .01) for example */
     float abs = fabs(incr); char  frmt[8], code[32]; int digits = 1; 
     if(hasnumber){ *val = getnumber(0); return; }
     if(abs <= .003) digits=3; else if(abs <= .03) digits=2;
     sprintf(frmt, "%%.%de" , digits);
     sprintf(code, frmt, incr >0 ? (*val)*(1+abs):(*val)/(1+abs));
     sscanf(code, "%f", val); 
}
/**********************************************************************/
void keyboard(unsigned char key, int x, int y){
     #define  IF(K)            if(key==K)
     #define  PRESS(K,A,b)     IF(K){b;}IF((K-32)){A;}  
     /*was backwards in previous versions */
     #define  TOGGLE(K,flg)    IF(K){(flg) = getnumber(1-(flg));}
     #define  CYCLE(K,f,m)     PRESS((K), \
              getnumber((f)=(((f)+(m)-1)%(m))), getnumber((f)=(++(f)%(m)))) 
   /* Only ASCII characters can be processes by this GLUT callback function */ 
   IF(27)exit(0);                            /* ESC exit            */
   TOGGLE('v',binoc);                            /* cross-eyed STEREO   */
   CYCLE(' ', mode,TURNMODE+1);                  /* fly/turn modes      */
#if 0
/*   TOGGLE('h',morph);                            /* autotymer on/off    */
#endif 
   TOGGLE('w',msg);                              /* writing on/off      */
   TOGGLE('f',friz);                              /* firz on/off      */
   TOGGLE('d',tubed);
   PRESS('n', bump(&nose, -.001), bump(&nose,.001))  /* for binoculars      */
   PRESS('s', bump(&speed,-.02), bump(&speed,.02)) /* flying speed        */
   PRESS('q', bump(&torq, -.02),  bump(&torq,.02)) /* turning speed        */
   PRESS('o', bump(&focal,-.1) ,   bump(&focal,.1))  /* telephoto    */ 
   PRESS('i', bump(&mysiz,-.1) ,   bump(&mysiz, .1))  /* rescale the world   */
 /*  PRESS('p', bump(&wfar, -.01) , bump(&wfar, .01))    /* rear clipping plane */
   TOGGLE('p', place)          /* AFF or SPH */ 
   PRESS('z', deFault(), deFault())             /* zap changes         */
   PRESS('g',bump(&gap, -.1), bump(&gap,.1))          /* gap parameter      */
   PRESS('a',bump(&amb, -.1), bump(&amb,.1))          /* ambient fraction   */
   PRESS('r',bump(&pwr, -.1), bump(&pwr,.1))          /* pseudo-spec power  */
   PRESS('u',bump(&r2, -.1), bump(&r2,.1))          /* little radius */
   PRESS('t',bump(&alpha, -.01), bump(&alpha,.01)) /*transparency*/
 /*PRESS('d',bump(&thick, -.01), bump(&thick,.01)) /*thickness of tubes*/
   PRESS('h',bump(&aitch, -.01), bump(&aitch,.01)) 
   PRESS('k',bump(&kay, -.01), bump(&kay,.01)) 
   PRESS('l',bump(&ell, -.01), bump(&ell,.01)) 
   IF(','){tan1=1-tan1;} /*1st tangent visible*/ 
   IF('<'){tan2=1-tan2;} /*2nd tangent visible*/ 
   IF('.'){cur2=1-cur2;} /*2-curve visible*/

   prj[0]=prj[5]=aitch - kay; 
   prj[10]= -ell;
   prj[14]= ell*aitch;
   prj[11]= -1;
   prj[15]= aitch;

/* Stuart Levy's gadget parser from avn.c */ 
   if(key >= '0' && key <= '9'){ hasnumber = 1; 
         number = 10*number + (key - '0'); decimal *= 10;}
   else if(key == '.'){ decimal = 1;}
   else if(key == '-'){ sign = -1;}
   else {hasnumber = number = decimal = sign = 0;}
   glutPostRedisplay(); 
}
/**********************************************************************/
void special_keybo(int key, int x, int y){
/*non-ASCII keypresses go here, if you're lucky enough to know their names */
 fprintf(stderr," non-ASCII character was pressed.\n");
 fprintf(stderr," use special_keybo() to process it\n");
}
/**********************************************************************/

float speedometer(void){                      /* this one is for win32*/ 
  double dbl; static double rate; static int ii=0;
  static struct _timeb lnow, lthen;
    if(++ii % 8 == 0){                 /* 8 times around measure time */
	   _ftime(&lnow);
		dbl =  (double)(lnow.time - lthen.time)
			 +(double)(lnow.millitm - lthen.millitm)/1000;
		lthen = lnow;  rate = 8/dbl;
      }
    return((float)rate);
}
/**********************************************************************/
#if 0
float speedometer(void){
double dbl; static double rate; static int ii=0;
static struct timezone notused; static struct timeval now, then;
   if(++ii % 8 == 0){  /* 8 times around measure time */
      gettimeofday(&now, &notused); /* elapsed time */
      dbl =  (double)(now.tv_sec - then.tv_sec)
         +(double)(now.tv_usec - then.tv_usec)/1000000;
      then = now;  rate = 8/dbl;
      }
   return((float)rate);
}
#endif
/**********************************************************************/
void char2wall(float x,float y,float z, char buf[]){
     char *p; glRasterPos3f(x,y,z);
     for(p = buf;*p;p++) glutBitmapCharacter(GLUT_BITMAP_9_BY_15,*p);
}
/**********************************************************************/
void messages(void){     
  char buf[256]; /* console messages are done differently from cave */
#define  LABEL2(x,y,W,u) {sprintf(buf,(W),(u));char2wall(x,y,0.,buf);}
  glMatrixMode(GL_PROJECTION); glPushMatrix(); glLoadIdentity();
  gluOrtho2D(0,3000,0,3000);
  glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();
      /*bull's eye*/
      if(mode==TURNMODE) glColor3f(0x22/255.,0x88/255.,0xdd/255.);
        else      glColor3f(.8,.8,.8);
      LABEL2(1500,1500,"%s","o");
      /* writings */
      if(mode==TURNMODE) glColor3f(1.,0.,1.);
        else      glColor3f(1.,1.,0.);
      LABEL2(80,80,"%4.1f fps",speedometer());
      LABEL2(80,2840,\
      "(ESC)ape (V)Binoc (MAUS2)Fore (BAR)Flymode %s (H)omotopy (W)riting",
             mode?"FLYING":"CONTROL");
      LABEL2(10,10,"illiTantrix \
   by Y. Malysheva, A. Chatwani, E. Denne, U Illinois, 2002 %s","");
      LABEL2(80,2770,"(N)ose   %0.3f",nose);
      LABEL2(80,2700,"(S)peed  %0.3f",speed);
      LABEL2(80,2630," tor(Q) %0.3f",torq);
      LABEL2(80,2560,"near clipper %g", mysiz*focal);
      LABEL2(80,2490,"f(O)cal factor %g",focal);
      LABEL2(80,2420,"my s(I)ze %0.3f",mysiz);
/*      LABEL2(80,2350,"wfar cli(P)er= %0.3f",wfar); */
      LABEL2(80,2280,"(Z)ap %s","");
      LABEL2(80,2210,"(G)ap %0.3f",gap);
      LABEL2(80,2140,"(A)mb %0.3f",amb);
      LABEL2(80,2070,"pw(R) %0.3f",pwr);
      LABEL2(80,1930,"tube rad(U) %0.3f",r2);
      LABEL2(80,1860,"(T)ransparency %0.3f",alpha);
      LABEL2(80,1790,"(F)riz %i",friz);
      LABEL2(80,1720,"(P)lace %i",place);
     
    glPopMatrix();
glMatrixMode(GL_PROJECTION); glPopMatrix();
} 
/**********************************************************************/
void chaptrack(int but,int xx,int yy,int shif){
   long dx,dy; 
  if(friz) return;
   dx = xx -.5*xt; dx = abs(dx)>5?dx:0;
   dy = yy -.5*yt; dy = abs(dy)>5?dy:0;

   glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();

   if(mode==TURNMODE) glTranslatef(aff[12],aff[13],aff[14]);
   glRotatef(dx*torq,0.,1.,0.); glRotatef(dy*torq,1.,0.,0.);
   if(but&(1<<GLUT_RIGHT_BUTTON ))glRotatef(shif?-10:-1,0.,0.,1.);
   if(but&(1<<GLUT_LEFT_BUTTON  ))glRotatef(shif?10:1,0.,0.,1.);
   if(mode==FLYMODE){
      glPushMatrix();
      glMultMatrixf(starmat);
      glGetFloatv(GL_MODELVIEW_MATRIX,starmat);
      glPopMatrix();
   }
   if(but&(1<<GLUT_MIDDLE_BUTTON)) glTranslatef(0.,0.,shif ? -speed : speed);
   if(mode==TURNMODE) glTranslatef(-aff[12],-aff[13],-aff[14]);
   glMultMatrixf(aff); 
   glGetFloatv(GL_MODELVIEW_MATRIX,aff);
   FOR(ii,0,3){luxx[ii]=0; FOR(jj,0,3)luxx[ii] +=aff[ii*4+jj]*lux[jj];}
   glPopMatrix();
}

/**********************************************************************/
void sphtrack(int but,int xx,int yy,int shif){
   long dx,dy;
  if(friz) return;
   dx = xx -.5*xt; dx = abs(dx)>5?dx:0;
   dy = yy -.5*yt; dy = abs(dy)>5?dy:0;

   glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();

   if(mode==TURNMODE) glTranslatef(sph[12],sph[13],sph[14]);
   glRotatef(dx*torq,0.,1.,0.); glRotatef(dy*torq,1.,0.,0.);
   if(but&(1<<GLUT_RIGHT_BUTTON ))glRotatef(shif?-10:-1,0.,0.,1.);
   if(but&(1<<GLUT_LEFT_BUTTON  ))glRotatef(shif?10:1,0.,0.,1.);
   if(mode==FLYMODE){
      glPushMatrix();
      glMultMatrixf(starmat);
      glGetFloatv(GL_MODELVIEW_MATRIX,starmat);
      glPopMatrix();
   }
   if(but&(1<<GLUT_MIDDLE_BUTTON)) glTranslatef(0.,0.,shif ? -speed : speed);
   if(mode==TURNMODE) glTranslatef(-sph[12],-sph[13],-sph[14]);
   glMultMatrixf(sph);
   glGetFloatv(GL_MODELVIEW_MATRIX,sph);
   FOR(ii,0,3){luxx[ii]=0; FOR(jj,0,3)luxx[ii] +=sph[ii*4+jj]*lux[jj];}
   glPopMatrix();
}


/**********************************************************************/
void drawcyll(float*,float*);
void drawball();

/**********************************************************************/
float* cross(float v[3], float u[3])
{
  float *result;
  result=calloc(3, sizeof(float));
  result[0]=v[1]*u[2]-v[2]*u[1];
  result[1]=v[2]*u[0]-v[0]*u[2];
  result[2]=v[0]*u[1]-v[1]*u[0];
  return result;
}
/**********************************************************************/

void garc0(float v1[3], float v2[3], int tor)
{
  int ii,jj;
  float dot, theta, dtheta, perp[3], *cp;
  float a[3],b[3];
  dot=(v1[0]*v2[0]
     + v1[1]*v2[1]
     + v1[2]*v2[2]);
  theta=acos(dot);
  for(jj=0; jj<3; jj++)
    perp[jj]=(v2[jj]-dot*v1[jj])/sin(theta);
  /*torus:*/
  if(tor)
    {
      th1=(int)(theta/(DG));
      cp=cross(v1, perp);/*cross product*/
      for(ii=0; ii<3; ii++)
	{
	  ptor[ii]=v1[ii];
	  ptor[4+ii]=perp[ii];
	  ptor[8+ii]=cp[ii];
	  ptor[12+ii]=0;
	  ptor[(ii+1)*4-1]=0;
	}
      ptor[15]=1;
      glPushMatrix();
      glMultMatrixf(ptor);
      drawtor();
      glPopMatrix();
    }
  /*end torus*/
  for(dtheta=0; dtheta<theta-theta/50; dtheta+=theta/48)
    {
      a[0]=v1[0]*cos(dtheta)+sin(dtheta)*perp[0];
      a[1]=v1[1]*cos(dtheta)+sin(dtheta)*perp[1];
      a[2]=v1[2]*cos(dtheta)+sin(dtheta)*perp[2];
      b[0]=v1[0]*cos(dtheta+theta/48)+sin(dtheta+theta/48)*perp[0];
      b[1]=v1[1]*cos(dtheta+theta/48)+sin(dtheta+theta/48)*perp[1];
      b[2]=v1[2]*cos(dtheta+theta/48)+sin(dtheta+theta/48)*perp[2];
      /*lift:*/
      for(ii=0; ii<3; ii++)
	{
	  a[ii]=a[ii]*(1+lift);
	  b[ii]=b[ii]*(1+lift);
	}
      glBegin(GL_LINES);
      glVertex3fv(a);
      glVertex3fv(b);
      glEnd();
    }
}
/**********************************************************************/
void garc(float v1[3], float v2[3])
{
  glColor3f(color[0], color[1], color[2]);
  glPushMatrix();
  glMultMatrixf(prj); 
  garc0(v1, v2, 0);
  glPopMatrix();

  garc0(v1, v2, tubed);
}
/**********************************************************************/
void tantrix()
{
  int ii,jj;
  float abs;/*abs. value of vector from one vertex to the next*/
  float u[3],v[3];
/*finding points on tantrix:*/
  for(ii=0; ii<VERT; ii++)
    {
      abs=sqrt((vv[(ii+1)%VERT][0]-vv[ii][0])*(vv[(ii+1)%VERT][0]-vv[ii][0])
             + (vv[(ii+1)%VERT][1]-vv[ii][1])*(vv[(ii+1)%VERT][1]-vv[ii][1]) 
             + (vv[(ii+1)%VERT][2]-vv[ii][2])*(vv[(ii+1)%VERT][2]-vv[ii][2]));
      for(jj=0; jj<3; jj++)
	{
	  ww[ii][jj]=(vv[(ii+1)%VERT][jj]-vv[ii][jj])/abs;
	}
    }
/*drawing great arcs between found points:*/
  for(ii=0; ii<VERT; ii++)
    {
      if(tan1>0)
	{
	  glColor3f(1,.1,.15);
	  color[0]=1;color[1]=.1; color[2]=.15;

	  garc(ww[ii], ww[(ii+1)%VERT]);  /* great arc */

	}
      if(tan2>0)
	{
	  glColor3f(1,.4,.1);
	  color[0]=1; color[1]=.4;color[2]=.1;
	  for(jj=0; jj<3; jj++)
	    {
	      u[jj]=-ww[ii][jj];
	      v[jj]=-ww[(ii+1)%VERT][jj];
	    }

	  garc(u,v);
	}
    }
}
/**********************************************************************/
void IIcurve()
{
   int i,j,m;
   float normal[3];
   float A[3], B[3], C[3], D[3], E[3], F[3], *A_cross_B, *D_cross_E;
   float prev_x, prev_y, prev_z, next_x, next_y, next_z, curr_x, curr_y, curr_z;
   float dot, theta, dtheta;
   float perp[3];
   float denom;
   float x1,x2,x3,y1,y2,y3,z1,z2,z3;
   int counter = 0;
   float vector1[3], vector2[3], vector3[3], vector4[3];
   
   
   /*get all the vertices and all of the lines*/
   for(i= 0; i < VERT; i++){    
      for(j = (i+2); j%VERT != (i+VERT-2)%VERT; j++){

	 /* Store v(i), v(i-1), and v(i+1) */
	 curr_x = vv[i][0];
	 curr_y = vv[i][1];
	 curr_z = vv[i][2];
	 
	 prev_x = vv[(i+VERT-1)%VERT][0];
	 prev_y = vv[(i+VERT-1)%VERT][1];
	 prev_z = vv[(i+VERT-1)%VERT][2];
	 
	 next_x = vv[(i+1)%VERT][0];
	 next_y = vv[(i+1)%VERT][1];
	 next_z = vv[(i+1)%VERT][2];

	 
	 /* Calculate vectors to use to calculate if v(i-1) and v(i+1) are on plane */
	 A[0] = prev_x - curr_x;
	 A[1] = prev_y - curr_y;
	 A[2] = prev_z - curr_z;
	 
	 B[0] = vv[j%VERT][0] - curr_x;
	 B[1] = vv[j%VERT][1] - curr_y;
	 B[2] = vv[j%VERT][2] - curr_z;
	 
	 C[0] = vv[(j+1)%VERT][0] - curr_x;
	 C[1] = vv[(j+1)%VERT][1] - curr_y;
	 C[2] = vv[(j+1)%VERT][2] - curr_z;

	 D[0] = next_x - curr_x;
	 D[1] = next_y - curr_y;
	 D[2] = next_z - curr_z;
	 
	 E[0] = vv[j%VERT][0] - curr_x;
	 E[1] = vv[j%VERT][1] - curr_y;
	 E[2] = vv[j%VERT][2] - curr_z;

	 F[0] = vv[(j+1)%VERT][0] - curr_x;
	 F[1] = vv[(j+1)%VERT][1] - curr_y;
	 F[2] = vv[(j+1)%VERT][2] - curr_z;

	 /* Begin taking determinant of matrices with cross project of top two rows, dot the 3rd row */
	 
	 A_cross_B = calloc(3, sizeof(float));
	 D_cross_E = calloc(3, sizeof(float));
	 
	 A_cross_B = cross(A, B);
	 D_cross_E = cross(D, E);

	 /* if both determinants have the same sign, then on the same side of the plane, so draw */
	 if (((DOT(A_cross_B, C)) * (DOT(D_cross_E, F))) > 0){ 

	    /* calculate vectors for great arc */
	    vector1[0] = vv[j%VERT][0] - vv[i][0];
	    vector1[1] = vv[j%VERT][1] - vv[i][1];
	    vector1[2] = vv[j%VERT][2] - vv[i][2];
	    denom = sqrt(vector1[0]*vector1[0] + vector1[1]*vector1[1] + vector1[2]*vector1[2]);
	    vector1[0] = vector1[0]/denom;
	    vector1[1] = vector1[1]/denom;
	    vector1[2] = vector1[2]/denom;
	    
	    vector2[0] = vv[(j+1)%VERT][0] - vv[i][0];
	    vector2[1] = vv[(j+1)%VERT][1] - vv[i][1];
	    vector2[2] = vv[(j+1)%VERT][2] - vv[i][2];
	    denom = sqrt(vector2[0]*vector2[0] + vector2[1]*vector2[1] + vector2[2]*vector2[2]);
	    vector2[0] = vector2[0]/denom;
	    vector2[1] = vector2[1]/denom;
	    vector2[2] = vector2[2]/denom;

	    /* vectors for antipodal two curve */
	    vector3[0] = -vector1[0];
	    vector3[1] = -vector1[1];
	    vector3[2] = -vector1[2];

	    vector4[0] = -vector2[0];
	    vector4[1] = -vector2[1];
	    vector4[2] = -vector2[2];
	    
	    glColor3f(0,0,1);
	    color[0] = 0;
	    color[1] = 0;
	    color[2] = 1;

	    garc(vector2, vector1);
	    garc(vector3, vector4);	  
	    
	 }
      }
      
      
   }
}
/**********************************************************************/
void drawbox(float *matr)
{
  glColor3f(1,1,1);
      glBegin(GL_LINE_STRIP);
      glVertex3f(0,0,0);
      glVertex3f(matr[0],matr[1],matr[2]);
      glVertex3f(matr[0]+matr[4],matr[1]+matr[5],matr[2]+matr[6]);
      glVertex3f(matr[0]+matr[4]+matr[8],matr[1]+matr[5]+matr[9],matr[2]+matr[6]+matr[10]);
      glVertex3f(matr[0]+matr[8],matr[1]+matr[9],matr[2]+matr[10]);
      glVertex3f(matr[8],matr[9],matr[10]);
      glVertex3f(matr[4]+matr[8],matr[5]+matr[9],matr[6]+matr[10]);
      glVertex3f(matr[4],matr[5],matr[6]);
      glVertex3f(0,0,0);
      glEnd();
}
/**********************************************************************/
void spot(float *n)
{
  float lmb,spec,grey;
  lmb = DOT(n,luxx);
  lmb =(lmb<0 ? .2 : lmb); 
  lmb = MAX(amb, lmb); 
  spec = CLAMP((1.1 - pwr+pwr*lmb), 0., 1.);
  grey=MAX(spec,lmb*.8);
  glColor4f(grey*color[0],grey*color[1],grey*color[2],alpha);
  glVertex3fv(n); 
}
/**********************************************************************/
void drawball()
{
  float u,v;
  float n[3],m[3];
  for(u=0; u<361;u+=30)
    {
      glBegin(GL_TRIANGLE_STRIP);
      for(v=-90; v<91;v+=15)
	{
	  n[0]=C(u)*C(v);
	  n[1]=S(u)*C(v);
	  n[2]=S(v);
	  m[0]=C(u+30)*C(v);
	  m[1]=S(u+30)*C(v);
	  m[2]=S(v);
	  
	  spot(n);
	  spot(m);
	}
      glEnd();
    }
}
/**********************************************************************/
void drawspot(void ){
      glPushMatrix();
      glColor3f(0,1,0);
      glTranslatef(aff[2],aff[6],aff[10]);
      glutWireSphere(0.1,4,4);      
      glPopMatrix();
}

/**********************************************************************/
void drawsphere()
{ 
  drawspot();

  if(alpha==1)
    {
      glColor4f(1,1,0,alpha);
      color[0]=1;color[1]=1;color[2]=.1;
      drawball();
      tantrix();
      if(cur2>0)
	{
	  IIcurve();
	}
    }
  else if(alpha==0)
    {
      glColor3f(1,.1,.1);
      tantrix();
      if(cur2>0)
	{
	  IIcurve();
	}
    }
  else
    {
      glEnable(GL_BLEND);
      glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
      
      glClear(GL_COLOR_BUFFER_BIT);
      
      glColor4f(1,1,.1,alpha);
      color[0]=1;color[1]=1;color[2]=.1;
      drawball();
      glDisable(GL_BLEND);
      tantrix();
      if(cur2>0)
	{
	  IIcurve();
	}
    }
}
/**********************************************************************/
void trot(float a[3], float b[3])
{
  int ii;
  float tt[3],nn[3],bb[3];/*tangent, normal, binormal - rot. frame*/
  float dot;
  float v2[3];/*temp. for new vertex*/
  for(ii=0; ii<3; ii++)
    pcan[ii]=tt[ii]=(b[ii]-a[ii])/sqrt((b[0]-a[0])*(b[0]-a[0])
                             +(b[1]-a[1])*(b[1]-a[1])
                             +(b[2]-a[2])*(b[2]-a[2]));
  if(tt[1]==0&&tt[2]==0)/*if tt is parallel to i=(1,0,0)*/
    {
      nn[0]=nn[2]=0;/*(then then normal can be j and binormal k)*/
      nn[1]=1;
      bb[0]=bb[1]=0;
      bb[2]=tt[0];
    }
  else /*otherwise we can take cross product of i and tt*/
    {
      dot=sqrt(tt[1]*tt[1]+tt[2]*tt[2]);
      nn[0]=0;
      nn[1]=tt[2]/dot;
      nn[2]=-tt[1]/dot;
      /*bb=tt cross nn*/
      bb[0]=tt[1]*nn[2]-tt[2]*nn[1];
      bb[1]=tt[2]*nn[0]-tt[0]*nn[2];
      bb[2]=tt[0]*nn[1]-tt[1]*nn[0];
    }
  for(ii=0; ii<3; ii++)
    {
      pcan[4+ii]=nn[ii];
      pcan[8+ii]=bb[ii];
      pcan[12+ii]=a[ii];
      pcan[(ii+1)*4-1]=0;
    }
  pcan[15]=1;
  glMultMatrixf(pcan);
}
/**********************************************************************/
void drawcyll(float *a, float *b)
{
  float theta, length, vertex[3];
  length=sqrt((b[0]-a[0])*(b[0]-a[0])
             +(b[1]-a[1])*(b[1]-a[1])
             +(b[2]-a[2])*(b[2]-a[2]));
  glPushMatrix();
  glPushMatrix();
  glTranslatef(a[0], a[1], a[2]);
  glScalef(thick,thick,thick);
  drawball();
  glPopMatrix();
  trot(a,b);
  glScalef(length,thick,thick);
  glBegin(GL_TRIANGLE_STRIP);
    for(theta=0; theta<(2*(3.14)+.2); theta+=((3.142)/4))
      {
	vertex[0]=0;vertex[1]=cos(theta);vertex[2]=sin(theta);
	spot(vertex);
	vertex[0]=1;vertex[1]=cos(theta);vertex[2]=sin(theta);
	glVertex3fv(vertex);
      }
  glEnd();
  glPopMatrix();
}
/**********************************************************************/
void drawknot()
{
  int ii;
  glColor3f(.2,1,.5);
  color[0]=.2;color[1]=1; color[2]=.5;
   for(ii=0; ii<VERT; ii++)
     {
       glBegin(GL_LINES);
        glVertex3fv(vv[ii]);
        glVertex3fv(vv[(ii+1)%VERT]);
       glEnd();
       drawcyll(vv[ii],vv[(ii+1)%VERT]);
     }
}
/**********************************************************************/
void reshaped(int xx, int yy){xt=xx ; yt=yy;}   /* origin of moved window */
/**********************************************************************/
void drawcons(void){  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  if(binoc) glViewport(0,yt/4,xt/2,yt/2);
  glMatrixMode(GL_PROJECTION); glLoadIdentity();
  glFrustum(-mysiz*xt/yt,mysiz*xt/yt,-mysiz,mysiz,mysiz*focal,wfar); 
  glMatrixMode(GL_MODELVIEW); glLoadIdentity();
  drawstars();
  glTranslatef(-binoc*nose,0.0,0.0);
  glMultMatrixf(sph);
  drawsphere();
  /*drawbox(matr);*/
  if(binoc){
    glViewport(xt/2,yt/4,xt/2,yt/2); 
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    drawstars();
    glTranslatef(binoc*nose,0.0,0.0);
    glMultMatrixf(aff);
    drawknot();
    }
  glViewport(0,0,xt,yt);
  if(msg) messages();
  glutSwapBuffers();
}

/**********************************************************************/
void idle(void){ /*do this when nothing else is happening*/
   if(morph) autotymer(0);  /* advance autotymer */ 
   glutPostRedisplay();  /*redraw the window*/
   if(place==AFF)chaptrack(BUT,XX,YY,SHIF);
   if(place==SPH)sphtrack(BUT,XX,YY,SHIF);
}

/**********************************************************************/
void mousepushed(int but,int stat,int x,int y){
  if(stat==GLUT_DOWN) BUT |= (1<<but);
  else BUT &= (-1 ^ (1<<but));  
  XX=x; YY=y; SHIF=(glutGetModifiers()==GLUT_ACTIVE_SHIFT)?1:0;
}

/**********************************************************************/
void mousemoved(int x,int y){  XX=x; YY=y; }
/**********************************************************************/
int main(int argc, char **argv){  
   arguments(argc,argv); 
   deFault(); 
 
       glutInit(&argc, argv);
       glutInitDisplayMode(GLUT_DOUBLE|GLUT_DEPTH);
       switch(win){ 
           case 0: break;  /* manage your own window */
           case 1: glutInitWindowSize(640, 480);
                   glutInitWindowPosition(100,100); break;
           case 2: glutInitWindowPosition(0,0); break;
         }
       glutCreateWindow("<* illiSkel in C/OpenGL/GLUT *>");
       if(win==2) glutFullScreen();
       glEnable(GL_DEPTH_TEST);
       glutDisplayFunc(drawcons);       
       glutKeyboardFunc(keyboard);
       glutSpecialFunc(special_keybo);
       glutMouseFunc(mousepushed);
       glutMotionFunc(mousemoved);       
       glutPassiveMotionFunc(mousemoved); 
       glutReshapeFunc(reshaped);
       glutIdleFunc(idle);             
       glutMainLoop();
}
 

